<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row>
    <v-col>
      <v-card>
        <v-card-title>
          Benutzer
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>
        <v-snackbar
          v-if="applicationStore.session.user.permissions.includes('ADMIN')"
          v-model="snackbar.show"
          :color="snackbar.failure ? 'error' : 'success'"
          top
          multi-line
          vertical
        >
          <div>
            {{ snackbar.message }}
          </div>
        </v-snackbar>
        <v-overlay
          v-if="applicationStore.session.user.permissions.includes('ADMIN')"
          :value="permissionOverlay.show"
        >
          <v-card>
            <v-card-title
              >Rechte für Benutzer "{{ permissionOverlay.user.name }}" hinzufügen</v-card-title
            >
            <v-card-text>
              <v-autocomplete
                v-model="permissionOverlay.toAdd"
                :items="permissionOverlay.canAdd"
                outlined
                dense
                chips
                small-chips
                multiple
                item-text="value"
                item-value="id"
                prepend-icon="mdi-account-check-outline"
                label="Rechte"
                :disabled="permissionOverlay.loading"
              >
              </v-autocomplete>
            </v-card-text>
            <v-card-actions>
              <v-btn @click="permissionOverlay.show = false" :disabled="permissionOverlay.loading"
                >Abbrechen</v-btn
              >
              <v-spacer />
              <v-btn
                :disabled="permissionOverlay.loading || permissionOverlay.toAdd.length === 0"
                :loading="permissionOverlay.loading"
                @click="commitPermissionOverlay"
              >
                Hinzufügen
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-overlay>
        <v-overlay
          v-if="applicationStore.session.user.permissions.includes('ADMIN')"
          :value="editUserOverlay.show"
        >
          <v-card>
            <v-card-title
              >Namen von Benutzer "{{ editUserOverlay.user.displayName }}" ändern</v-card-title
            >
            <v-card-text>
              <v-form ref="editUserForm">
                <v-text-field
                  label="Vorname"
                  prepend-icon="mdi-account-box"
                  v-model="editUserOverlay.user.firstname"
                  :rules="nameRules"
                  :disabled="editUserOverlay.loading"
                />
                <v-text-field
                  label="Nachname"
                  prepend-icon="mdi-account-box-outline"
                  v-model="editUserOverlay.user.surname"
                  :rules="nameRules"
                  :disabled="editUserOverlay.loading"
                />
                <v-text-field
                  label="Anzeigename"
                  prepend-icon="mdi-card-account-details"
                  append-icon="mdi-lightbulb-outline"
                  @click:append="setFullNameSuggestion"
                  :hint="`Empfehlung: ${editUserOverlay.user.firstname} ${editUserOverlay.user.surname}`"
                  :placeholder="`${editUserOverlay.user.firstname} ${editUserOverlay.user.surname}`"
                  v-model="editUserOverlay.user.displayName"
                  :disabled="editUserOverlay.loading"
                  :rules="fullNameRules"
                />
                <v-checkbox
                  v-model="editUserOverlay.verified"
                  :rules="[(v) => !!v || 'Die Zustimmung ist erforderlich']"
                  :disabled="editUserOverlay.loading"
                  required
                >
                  <template v-slot:label>
                    Ich habe die Identität des Benutzers mithilfe eines Ausweisdokuments überprüft
                    oder der kenne ihn persönlich.
                  </template>
                </v-checkbox>
              </v-form>
            </v-card-text>
            <v-card-actions>
              <v-btn @click="editUserOverlay.show = false" :disabled="editUserOverlay.loading"
                >Abbrechen</v-btn
              >
              <v-spacer />
              <v-btn
                :disabled="editUserOverlay.loading"
                :loading="editUserOverlay.loading"
                @click="commitUserNameOverlay"
              >
                Ändern
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-overlay>
        <v-overlay
          v-if="applicationStore.session.user.permissions.includes('ADMIN')"
          :value="editMailOverlay.show"
        >
          <v-card>
            <v-card-title
              >Mailadresse von Benutzer "{{ editMailOverlay.user.displayName }}"
              ändern</v-card-title
            >
            <v-card-text>
              <v-form ref="editMailForm">
                <v-text-field
                  label="E-Mail"
                  prepend-icon="mdi-mail"
                  v-model="editMailOverlay.user.mail"
                  :rules="[util.validateMail]"
                  :disabled="editMailOverlay.loading"
                />
                <v-checkbox
                  v-model="editMailOverlay.verified"
                  :rules="[(v) => !!v || 'Die Zustimmung ist erforderlich']"
                  :disabled="editMailOverlay.loading"
                  required
                >
                  <template v-slot:label>
                    Ich habe die Identität des Benutzers mithilfe eines Ausweisdokuments überprüft
                    oder kenne ihn persönlich.
                  </template>
                </v-checkbox>
              </v-form>
            </v-card-text>
            <v-card-actions>
              <v-btn @click="editMailOverlay.show = false" :disabled="editMailOverlay.loading"
                >Abbrechen</v-btn
              >
              <v-spacer />
              <v-btn
                :disabled="editMailOverlay.loading"
                :loading="editMailOverlay.loading"
                @click="commitUserMailOverlay"
              >
                Ändern
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-overlay>
        <v-data-table
          :headers="headers"
          :items="items"
          :search="search"
          :loading="loading"
          single-expand
          show-expand
        >
          <template v-slot:item.disabled="row">
            <v-icon v-if="row.item.disabled">mdi-account-cancel</v-icon>
          </template>
          <template v-slot:expanded-item="{ headers, item }">
            <td :colspan="headers.length" class="pa-4">
              <table>
                <tr>
                  <td>ID</td>
                  <td>
                    {{ item.id }}
                    <v-tooltip
                      bottom
                      v-if="
                        applicationStore.session.user.permissions.includes('ADMIN') && item.disabled
                      "
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          fab
                          x-small
                          outlined
                          v-bind="attrs"
                          v-on="on"
                          @click="enableUser(item)"
                          :disabled="changingUserStatus"
                        >
                          <v-icon>mdi-account-check</v-icon>
                        </v-btn>
                      </template>
                      <span>Aktivieren</span>
                    </v-tooltip>
                    <v-tooltip
                      bottom
                      v-if="
                        applicationStore.session.user.permissions.includes('ADMIN') &&
                        !item.disabled &&
                        applicationStore.session.user.id != item.id &&
                        !item.permissions.includes('ADMIN')
                      "
                    >
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          fab
                          x-small
                          outlined
                          v-bind="attrs"
                          v-on="on"
                          @click="disableUser(item)"
                          :disabled="changingUserStatus"
                        >
                          <v-icon>mdi-account-cancel</v-icon>
                        </v-btn>
                      </template>
                      <span>Deaktivieren</span>
                    </v-tooltip>
                  </td>
                </tr>
                <tr v-if="applicationStore.session.user.permissions.includes('ADMIN')">
                  <td>Username</td>
                  <td>{{ item.username }}</td>
                </tr>
                <tr v-if="applicationStore.session.user.permissions.includes('ADMIN')">
                  <td>Voller Name</td>
                  <td>
                    {{
                      item.displayName !== `${item.firstname} ${item.surname}`
                        ? `${item.firstname} ${item.surname} (${item.displayName})`
                        : item.displayName
                    }}
                    <v-btn fab x-small outlined @click="changeUserName(item)">
                      <v-icon>mdi-pencil</v-icon>
                    </v-btn>
                  </td>
                </tr>
                <tr v-if="applicationStore.session.user.permissions.includes('ADMIN')">
                  <td>E-Mail</td>
                  <td>
                    {{ item.mail }}
                    <v-btn fab x-small outlined @click="changeUserMail(item)">
                      <v-icon>mdi-pencil</v-icon>
                    </v-btn>
                  </td>
                </tr>
                <tr v-if="applicationStore.session.user.permissions.includes('ADMIN')">
                  <td>Last login</td>
                  <td>
                    {{ item.lastLoginAt }}
                  </td>
                </tr>
                <tr>
                  <td>Gruppenmitglied</td>
                  <td>
                    <v-chip
                      v-for="group in getSortedGroupsById(item.groups)"
                      :key="group.id"
                      class="ma-1"
                      outlined
                    >
                      {{ group.name }}
                    </v-chip>
                  </td>
                </tr>
                <tr>
                  <td>Gruppenadministrator</td>
                  <td>
                    <v-chip
                      v-for="group in getSortedGroupsById(item.ownedGroups)"
                      :key="group.id"
                      class="ma-1"
                      outlined
                    >
                      {{ group.name }}
                    </v-chip>
                  </td>
                </tr>
                <tr v-if="applicationStore.session.user.permissions.includes('ADMIN')">
                  <td>Rechte</td>
                  <td>
                    <v-chip
                      class="ma-1"
                      outlined
                      close
                      close-icon="mdi-plus-circle"
                      @click:close="addPermissionToUser(item)"
                    >
                      Hinzufügen
                    </v-chip>
                    <v-chip
                      v-for="permission in item.permissions"
                      :key="permission"
                      class="ma-1"
                      outlined
                      :close="!permissionsChanging"
                      close-icon="mdi-delete"
                      @click:close="removePermissionFromUser(item, permission)"
                    >
                      <v-progress-circular
                        indeterminate
                        size="20"
                        width="3"
                        v-if="permissionsChanging"
                      ></v-progress-circular>
                      <div v-else>
                        {{ permission }}
                      </div>
                    </v-chip>
                  </td>
                </tr>
              </table>
            </td>
          </template>
        </v-data-table>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import moment from 'moment';
import Api from '../../LegacyApi';
import Util from '../../LegacyUtil';
import { useApplicationStore } from '../../stores/application';

export default {
  methods: {
    getSortedGroupsById: function (ids) {
      return Util.getSortedGroupsById(ids, this.groups);
    },
    enableUser: function (user) {
      this.changingUserStatus = true;
      Api.defaultHandler(
        this,
        Api.changeUserStatus(user.id, false).then((data) => {
          user.disabled = data.disabled;
          this.users.set(data.id, user);
          this._computedWatchers.items.run();
          this.$forceUpdate();
          this.snackbar.message = 'Benutzer erfolgreich aktiviert';
          this.snackbar.failure = false;
          this.snackbar.show = true;
          this.changingUserStatus = false;
        })
      );
    },
    disableUser: function (user) {
      this.changingUserStatus = true;
      Api.defaultHandler(
        this,
        Api.changeUserStatus(user.id, true).then((data) => {
          user.disabled = data.disabled;
          this.users.set(data.id, user);
          this._computedWatchers.items.run();
          this.$forceUpdate();
          this.snackbar.message = 'Benutzer erfolgreich deaktiviert';
          this.snackbar.failure = false;
          this.snackbar.show = true;
          this.changingUserStatus = false;
        })
      );
    },
    addPermissionToUser: function (user) {
      this.permissionOverlay.user = user;
      this.permissionOverlay.canAdd = this.addablePermissions.filter(
        (x) => !user.permissions.includes(x)
      );
      this.permissionOverlay.toAdd = [];
      this.permissionOverlay.loading = false;
      this.permissionOverlay.show = true;
    },
    removePermissionFromUser: function (user, permission) {
      this.permissionsChanging = true;

      const newPermissions = user.permissions.filter((x) => x !== permission);

      Api.defaultHandler(
        this,
        Api.changePermissionsForUser(user.id, newPermissions).then((data) => {
          user.permissions = data;
          this._computedWatchers.items.run();
          this.$forceUpdate();
          this.snackbar.message = 'Recht erfolgreich entfernt';
          this.snackbar.failure = false;
          this.snackbar.show = true;
          this.permissionsChanging = false;
        })
      );
    },
    commitPermissionOverlay: function () {
      this.permissionOverlay.loading = true;
      const newPermissions = [
        ...this.permissionOverlay.user.permissions,
        ...this.permissionOverlay.toAdd,
      ];
      Api.defaultHandler(
        this,
        Api.changePermissionsForUser(this.permissionOverlay.user.id, newPermissions).then(
          (data) => {
            this.permissionOverlay.user.permissions = data;
            this._computedWatchers.items.run();
            this.$forceUpdate();
            this.permissionOverlay.show = false;
            this.snackbar.message = 'Recht erfolgreich hinzugefügt';
            this.snackbar.failure = false;
            this.snackbar.show = true;
            this.permissionsChanging = false;
          }
        )
      );
    },
    changeUserName: function (user) {
      this.editUserOverlay.user = Object.assign({}, user);
      this.editUserOverlay.verified = false;
      this.editUserOverlay.loading = false;
      this.editUserOverlay.show = true;
    },
    setFullNameSuggestion: function () {
      this.editUserOverlay.user.displayName = `${this.editUserOverlay.user.firstname} ${this.editUserOverlay.user.surname}`;
    },
    commitUserNameOverlay: function () {
      if (this.$refs.editUserForm.validate()) {
        this.$emit('clearError');
        this.editUserOverlay.loading = true;
        Api.defaultHandler(
          this,
          Api.changeNameOfUser(
            this.editUserOverlay.user.id,
            this.editUserOverlay.user.displayName,
            this.editUserOverlay.user.firstname,
            this.editUserOverlay.user.surname,
            this.editUserOverlay.verified
          ).then((data) => {
            this.editUserOverlay.user.displayName = data.displayName;
            this.editUserOverlay.user.firstname = data.firstname;
            this.editUserOverlay.user.surname = data.surname;
            this.editUserOverlay.verified = false;
            this.users.set(data.id, this.editUserOverlay.user);
            this._computedWatchers.items.run();
            this.$forceUpdate();
            this.editUserOverlay.show = false;
            this.snackbar.message = 'Name erfolgreich geändert';
            this.snackbar.failure = false;
            this.snackbar.show = true;
          })
        );
      }
    },
    changeUserMail: function (user) {
      this.editMailOverlay.user = Object.assign({}, user);
      this.editMailOverlay.verified = false;
      this.editMailOverlay.loading = false;
      this.editMailOverlay.show = true;
    },
    commitUserMailOverlay: function () {
      if (this.$refs.editMailForm.validate()) {
        this.$emit('clearError');
        this.editMailOverlay.loading = true;
        Api.defaultHandler(
          this,
          Api.changeMailOfUser(
            this.editMailOverlay.user.id,
            this.editMailOverlay.user.mail,
            this.editMailOverlay.verified
          ).then((data) => {
            this.editMailOverlay.user.mail = data.mail;
            this.editMailOverlay.verified = false;
            this.users.set(data.id, this.editMailOverlay.user);
            this._computedWatchers.items.run();
            this.$forceUpdate();
            this.editMailOverlay.show = false;
            this.snackbar.message = 'E-Mail erfolgreich geändert';
            this.snackbar.failure = false;
            this.snackbar.show = true;
          })
        );
      }
    },
  },
  mounted: function () {
    Api.defaultHandler(this, Promise.all([Api.getAllGroups(), Api.getAllUsers()])).then(
      (result) => {
        this.groups = result[0];
        this.users = result[1];
        this.loading = false;
      }
    );
  },
  data: () => {
    return {
      snackbar: {
        show: false,
        failure: false,
        message: '',
      },
      permissionOverlay: {
        show: false,
        loading: false,
        user: {
          id: '',
          name: '',
        },
        canAdd: [],
        toAdd: [],
      },
      editUserOverlay: {
        show: false,
        loading: false,
        user: {
          id: '',
          displayName: '',
          firstname: '',
          surname: '',
        },
      },
      editMailOverlay: {
        show: false,
        loading: false,
        user: {
          id: '',
          displayName: '',
          mail: '',
        },
      },
      search: '',
      loading: true,
      changingUserStatus: false,
      permissionsChanging: false,
      users: new Map(),
      groups: new Map(),
      addablePermissions: [
        'INVITE',
        'RESET_SANDBOX',
        'UPLOAD_SUPPORT_MEMBER',
        'MANAGE_GDPR',
        'FUNCTION_ACCOUNT',
      ],
      nameRules: [
        (v) => !!v || 'Dieses Feld ist benötigt',
        (v) => (v || '').length >= 2 || 'Mindestens 2 Zeichen benötigt',
        (v) => (v || '').length <= 40 || 'Maximal 40 Zeichen',
      ],
      fullNameRules: [
        (v) => !!v || 'Bitte einen vollen Namen wählen',
        (v) => (v || '').length >= 3 || 'Der volle Name muss mindestens 3 Zeichen beinhalten',
        (v) => (v || '').length <= 80 || 'Der volle Name darf maximal 80 Zeichen beinhalten',
      ],
      applicationStore: useApplicationStore(),
    };
  },
  computed: {
    headers: function () {
      let basicHeaders = [
        {
          text: 'Anzeigename',
          value: 'displayName',
        },
        {
          text: 'Vorname',
          value: 'firstname',
        },
        {
          text: 'Nachname',
          value: 'surname',
        },
        {
          text: 'E-Mail',
          value: 'mail',
        },
      ];

      const permissions = this.applicationStore.session.user.permissions;

      let adminHeaders = permissions.includes('ADMIN')
        ? [
            {
              text: 'Rechte',
              value: 'permissions',
            },
            {
              text: 'Deaktiviert',
              value: 'disabled',
            },
          ]
        : [];

      return basicHeaders.concat(adminHeaders);
    },
    items: function () {
      return Array.from(this.users.values()).map((user) =>
        Object.assign(user, {
          lastLoginAt:
            user.lastLoginAt === '1970-01-01T00:00:00Z'
              ? 'niemals'
              : moment(user.lastLoginAt).format('YYYY-MM-DD HH:mm:ss'),
        })
      );
    },
  },
  beforeUnmount() {
    this.$emit('clearError');
  },
};
</script>

<style scoped></style>
